%% Lezione 9 Lab: K-means
% Scopo dell'esercitazione e' implementare e validare un algoritmo di
% clustering partizionale, il K-means.

clear all
close all
clc

%% Prima parte: costruzione del dataset

% Genero casualmente da tre gaussiane bidimensionali
mu1 = [1 1];
mu2 = [2 3];
mu3 = [-2 5];
sigma = [0.5 0; 0 0.5];

X1 = mvnrnd(mu1, sigma, 100);
X2 = mvnrnd(mu2, sigma, 100);
X3 = mvnrnd(mu3, sigma, 100);

data = [X1' X2' X3'];
scatter(data(1,:), data(2,:));

[nfeat, nobj] = size(data);

%% Implementazione: linee guida

% Decido a priori il numero di cluster
n_cluster = 3;

% Inizializzazione
% (suggerimento: partire da una clusterizzazione iniziale.
% Assegno ad ogni punto un etichetta a caso tra 1 e n_cluster.
% Controllare l'help del comando randi)


% Continuo a ciclare; in ogni passo del ciclo:
% - Per ogni cluster, calcolo la media dei suoi punti (sto ri-stimando i
% centri di cluster)
% - Per ogni punto, calcolo la sua distanza (euclidea) da ogni centro di cluster, quindi
% ri-calcolo le etichette: ogni punto è assegnato al cluster più vicino.
% - Controllo se l'algoritmo è arrivato a convergenza:
% come: se le nuove etichette sono uguali a quelle del passo precedente.

iter = 0;
while true
         
    iter = iter+1;
    
    %Calcolo le medie dei cluster
    
    %Per ogni punto, calcolo la distanza da ogni cluster
    
    %Per ogni punto, trovo il cluster piu' vicino
          
    %Check per la convergenza
    %(comando break per uscire dal ciclo)

end


%% Esercizio 2:
% Provare a clusterizzare un dataset monodimensionale, in particolar modo
% l'immagine "T1.png".
% Le feature sono i livelli di grigio, 
% gli oggetti da classificare sono i singoli pixel. 
% Con 3 cluster, si riescono a separare le varie regioni del cervello?
% (materia bianca, materia grigia, fluido cerebro-corticale)
I = im2double(imread('T1.png'));
subplot(1,2,1), imshow(I); title('Original image');
data = I(:)';
[nfeat, nobj] = size(data);

% Una volta che ad ogni pixel è stata assegnata un etichetta in una
% variabile chiamata (ad es.) labels, per visualizzare l'immagine:
% I_cluster = reshape(labels,size(I));






